function loadListener(){
  this.removeEventListener("load", loadListener, true);
  this.loadURIWithFlags(this.getAttribute("wmn_url"));            
  this.removeAttribute("wmn_url");
}
WebMailNotifier.prototype.openTab = function(url,name,reuse,mailDomain,newWin) {
  if(reuse){
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var enm = wm.getEnumerator("navigator:browser");
    while(enm.hasMoreElements()){
      var tabbrowser = enm.getNext().getBrowser();
      for (var i = 0;i< tabbrowser.mTabContainer.childNodes.length;i++){
        var tab = tabbrowser.mTabContainer.childNodes[i];
        if (tab.hasAttribute("tabname")&&tab.getAttribute("tabname")==name) {
          var browser=tabbrowser.getBrowserForTab(tab);
          if(this.canReuse(browser.currentURI,mailDomain)){
            if(!this.multiSession&&name=="wmn_gmail"){
              browser.setAttribute("wmn_url",url);
              browser.addEventListener("load", loadListener, true);            
              browser.loadURIWithFlags("about:blank");            
            }else browser.loadURIWithFlags(url);
            tabbrowser.selectedTab = tab;
            tabbrowser.contentWindow.focus();            
            return;
          }else{
            tab.removeAttribute("tabname");
            browser.removeProgressListener(this);                
          }
        }
      }
    }
  }
  //not found
  var win=this.getWindow(true);
  if(newWin){
    win.open("about:blank");
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                        .getService(Components.interfaces.nsIWindowMediator);
    win = wm.getMostRecentWindow("navigator:browser");
  }
  var tabbrowser=win.getBrowser();
  var tab = tabbrowser.selectedTab;
  if(tabbrowser.currentURI.spec=="about:blank"
      &&!tab.hasAttribute("tabname")){
    tab.setAttribute("tabname",name);   
    if(this.multiSession)tabbrowser.selectedBrowser.addProgressListener(this);
    tabbrowser.loadURIWithFlags(url);
  }else{
    tab=tabbrowser.addTab("about:blank");
    tab.setAttribute("tabname",name);
    tabbrowser.selectedTab = tab;
    if(this.multiSession)tabbrowser.selectedBrowser.addProgressListener(this);    
    tabbrowser.loadURIWithFlags(url);
  }
  win.focus();
}
WebMailNotifier.prototype.openNewWindow = function() {
    var win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    win.open("about:blank");
}
WebMailNotifier.prototype.openWindow = function(url,name,reuse,mailDomain) {
  this.openTab(url,name,reuse,mailDomain,true);
}
WebMailNotifier.prototype.getWindow = function(notChrome) {
 /* var win=Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
              .getService(Components.interfaces.nsIWindowWatcher).activeWindow;
  if(win==null){*/
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                      .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("navigator:browser");
  if(win==null){
    win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    if(notChrome){
      win.open("about:blank");
      win = wm.getMostRecentWindow("navigator:browser");
    }
  }
  return win;
}